Package org.eclipse.jgit.lib

## Interface Ref

All Known Implementing Classes:
  `ObjectIdRef`, `ObjectIdRef.PeeledNonTag`, `ObjectIdRef.PeeledTag`, `ObjectIdRef.Unpeeled`, `SymbolicRef`

    public interface Ref

Pairing of a name and the `ObjectId` it currently has.

A ref in Git is (more or less) a variable that holds a single object identifier. The object identifier can be any valid Git object (blob, tree, commit, annotated tag, ...).

The ref name has the attributes of the ref that was asked for as well as the ref it was resolved to for symbolic refs plus the object id it points to and (for tags) the peeled target object id, i.e. the tag resolved recursively until a non-tag object is referenced.

### Nested Class Summary

Nested Classes
`static class` `Ref.Storage` Location where a `Ref` is stored.

### Method Summary

All Methods Instance Methods Abstract Methods
`Ref` `getLeaf()` Traverse target references until `isSymbolic()` is false.
`String` `getName()` What this ref is called within the repository.
`ObjectId` `getObjectId()` Cached value of this ref.
`ObjectId` `getPeeledObjectId()` Cached value of `ref^{}` (the ref peeled to commit).
`Ref.Storage` `getStorage()` How was this ref obtained?
`Ref` `getTarget()` Get the reference this reference points to, or `this`.
`boolean` `isPeeled()`
`boolean` `isSymbolic()` Test if this reference is a symbolic reference.

### Method Detail

#### getName

    String getName()

What this ref is called within the repository.

Returns:
  name of this ref.

#### isSymbolic

    boolean isSymbolic()

Test if this reference is a symbolic reference.

A symbolic reference does not have its own `ObjectId` value, but instead points to another `Ref` in the same database and always uses that other reference's value as its own.

Returns:
  true if this is a symbolic reference; false if this reference contains its own ObjectId.

#### getLeaf

    Ref getLeaf()

Traverse target references until `isSymbolic()` is false.

If `isSymbolic()` is false, returns `this`.

If `isSymbolic()` is true, this method recursively traverses `getTarget()` until `isSymbolic()` returns false.

This method is effectively

     return isSymbolic() ? getTarget().getLeaf() : this;

Returns:
  the reference that actually stores the ObjectId value.

#### getTarget

    Ref getTarget()

Get the reference this reference points to, or `this`.

If `isSymbolic()` is true this method returns the reference it directly names, which might not be the leaf reference, but could be another symbolic reference.

If this is a leaf level reference that contains its own ObjectId,this method returns `this`.

Returns:
  the target reference, or `this`.

#### getObjectId

    ObjectId getObjectId()

Cached value of this ref.

Returns:
  the value of this ref at the last time we read it.

#### getPeeledObjectId

    ObjectId getPeeledObjectId()

Cached value of `ref^{}` (the ref peeled to commit).

Returns:
  if this ref is an annotated tag the id of the commit (or tree or blob) that the annotated tag refers to; null if this ref does not refer to an annotated tag.

#### isPeeled

    boolean isPeeled()

Returns:
  whether the Ref represents a peeled tag

#### getStorage

    Ref.Storage getStorage()

How was this ref obtained?

The current storage model of a Ref may influence how the ref must be updated or deleted from the repository.

Returns:
  type of ref.